## Title: Client_Project_multiThread.py
## Abstract:
## Author(s): Greg Greenleaf (pacohojaverde@gmail.com)
##            Alex Hauser (ahauser@csumb.edu)
##            Zac Leids (zleids@csumb.edu)
## Date: October 5, 2014

import socket
import sys
if (sys.version_info < (3,0)):
    import thread
else: import _thread as thread

#use global variables to ensure the threads have access to them
global inp, End, Response

#end conditions
End_All = 0
End = 0

#ip = "10.5.10.1" #Use this ip/port when testing on same pc
#port = 55555
 
ip = "10.5.10.1" #Use this ip/port when testing over ethernet
port = 55555


#Initialize a socket
client_socketA = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
client_socketA.connect((ip, port))

def inputAndSend():#handles user input and sending data
    global End_All
    print("Connected to server")
    End = 0
    while End == 0:
        if (sys.version_info < (3,0)):
            inp = raw_input("Enter 0-3, or 5 to close: ")
        else: inp = input("Enter 0-3, or 5 to close: ")
        if inp == '5' or inp == '\n' or inp == '' or inp == ' ' or len(inp) < 1 or inp == 'Goodbye':
            End = 1
            End_All = 1
            inp = "Goodbye"
        
        #Send the 'data' message to the server, encoded with utf-8
        client_socketA.send(inp.encode('utf-8'))
    return

def reciver():#handles receiving responses from the server
    End = 0
    while End == 0:
            response = client_socketA.recv(1024).decode('utf-8')
            #If the response is non-null and non-empty,
            #print the response and set End to 1 to end the loop
            if str(response):
                print("\nReceived " + str(response) +".")
                if response == "Close":
                    End = 1
                    client_socketA.close()
                    sys.exit()
    return

#start the threads
thread.start_new_thread(inputAndSend, ())
thread.start_new_thread(reciver, ())

while End == 0 and End_All == 0:
    if End != 0 or End_All != 0:
        thread.exit_thread()
        print(End_All)
        client_socketA.close()
        sys.exit()
        break

thread.exit_thread()
client_socketA.close()
sys.exit()
